import functools

from typing import Callable

from windows_server import client

from .records import WindowsServer


def winrm(func: Callable) -> Callable:
    @functools.wraps(func)
    def _winrm_command(windows_server: WindowsServer, *args, **kwargs):
        with client.initialize(
            host=windows_server["address"],
            port=5986 if windows_server["use_ssl"] else 5985,
            username=windows_server["username"],
            password=windows_server["password"],
            validate_cert=windows_server["validate_cert"],
            use_ssl=windows_server["use_ssl"],
        )() as open_connection:
            return func(open_connection, *args, **kwargs)

    return _winrm_command
